SystemOrganization addCategory: #Cart!
SystemOrganization addCategory: #'Cart-Test'!

Object subclass: #Book
	instanceVariableNames: 'isbn price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cart'!

!Book class methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 12:15'!
withIsbn: anIsbn andPrice: aPrice

	^Book new initializeWithIsbn: anIsbn andPrice: aPrice! !

!Book methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 16:39'!
= aBook

	^isbn = aBook isbn! !

!Book methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 16:17'!
hash

	^isbn hash! !

!Book methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 12:16'!
initializeWithIsbn: anIsbn andPrice: aPrice

	isbn := anIsbn.
	price := aPrice! !

!Book methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 16:37'!
isbn

	^isbn! !

Object subclass: #Cart
	instanceVariableNames: 'id books catalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cart'!

Cart class
	instanceVariableNames: 'idCounter'!

Cart class
	instanceVariableNames: 'idCounter'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 15:58'!
bookMustBeInTheCatalogErrorMessage

	^'The book is not in the catalog'! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 15:52'!
empty

	^Cart new initializeWithId: self nextId! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 15:52'!
emptyWithCatalog: aCatalog

	^Cart new initializeWithId: self nextId andCatalog: aCatalog! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 11:40'!
nextId

	^idCounter := idCounter + 1! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 17:09'!
quantityCanNotExceedTheCatalogErrorMessage

	^'Quantity for the book exceed the total in the cart'! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 12:56'!
quantityMustNotBeLessThanOneErrorMessage

	^'Quantity must be at least one'! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 12:28'!
resetId

	^idCounter := 0! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 17:33'!
addToCart: aBook withQuantity: aQuantity
	
	| totalQuantity |
	
	(catalog includes: aBook) ifFalse: [self signalBookMustBeInTheCatalog].
	
	(aQuantity < 1) ifTrue: [self signalQuantityMustNotBeLessThanOne].
	
	totalQuantity :=  (self quantityOf: aBook) + aQuantity.
		
	(totalQuantity > (catalog quantityOf: aBook)) ifTrue: [self signalQuantityCanNotExceedTheCatalog].
		
	books add: aBook withOccurrences: aQuantity! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 17:44'!
includes: aBook

	^books includes: aBook! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 15:52'!
initializeWithId: anId

	id := anId.
	books := Bag new! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 15:52'!
initializeWithId: anId andCatalog: aCatalog

	id := anId.
	books := Bag new.
	catalog := aCatalog! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 12:19'!
isEmpty

	^books isEmpty! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 16:56'!
quantityOf: aBook

	^books occurrencesOf: aBook! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 15:58'!
signalBookMustBeInTheCatalog

	self error: self class bookMustBeInTheCatalogErrorMessage! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 17:08'!
signalQuantityCanNotExceedTheCatalog

	self error: self class quantityCanNotExceedTheCatalogErrorMessage! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 12:55'!
signalQuantityMustNotBeLessThanOne

	self error: self class quantityMustNotBeLessThanOneErrorMessage! !

Object subclass: #Catalog
	instanceVariableNames: 'storedBooks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cart'!

!Catalog methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 14:25'!
addToCatalog: aBook withQuantity: aQuantity
	
	storedBooks add: aBook withOccurrences: aQuantity! !

!Catalog methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 16:06'!
includes: aBook

	^storedBooks includes: aBook! !

!Catalog methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 14:22'!
initialize

	storedBooks := Bag new.! !

!Catalog methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 17:18'!
quantityOf: aBook

	^storedBooks occurrencesOf: aBook! !

!Catalog methodsFor: 'as yet unclassified' stamp: 'Jamardo 6/13/2012 14:05'!
storedBooks

	^storedBooks! !

TestCase subclass: #CartTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cart-Test'!

!CartTest methodsFor: 'creation' stamp: 'Jamardo 6/13/2012 16:01'!
cart
	
	| aCatalog |
	
	aCatalog := self catalog.
	
	^Cart emptyWithCatalog: aCatalog! !

!CartTest methodsFor: 'creation' stamp: 'Jamardo 6/13/2012 17:25'!
catalog

	
	| whiteBook blackBook blueBook aCatalog|
	whiteBook := Book withIsbn: 123 andPrice: 5.
	blackBook := Book withIsbn: 456 andPrice: 10.
	blueBook := Book withIsbn: 789 andPrice: 15.
	
	aCatalog := Catalog new.
	aCatalog addToCatalog: whiteBook withQuantity: 5.
	aCatalog addToCatalog: blackBook withQuantity: 10.
	aCatalog addToCatalog: blueBook withQuantity: 15.
		
	^aCatalog! !

!CartTest methodsFor: 'cartTests' stamp: 'Jamardo 6/13/2012 11:53'!
test01NewCartMustBeEmpty

	self assert: self cart isEmpty! !

!CartTest methodsFor: 'cartTests' stamp: 'Jamardo 6/13/2012 16:50'!
test02AfterAddingABookToACartMustNotBeEmpty

	| aCart whiteBook |
	
	aCart := self cart.
	whiteBook := Book withIsbn: 123 andPrice: 5.
	aCart addToCart: whiteBook withQuantity: 1.
	self deny: aCart isEmpty! !

!CartTest methodsFor: 'cartTests' stamp: 'Jamardo 6/13/2012 17:55'!
test03WhenAddingTwoBooksTheyMustBeInTheCart

	| whiteBook blackBook aCart |
	
	whiteBook := Book withIsbn: 123 andPrice: 5.
	blackBook := Book withIsbn: 456 andPrice: 10.
	
	aCart := self cart.
	aCart addToCart: whiteBook withQuantity: 1.
	aCart addToCart: blackBook withQuantity: 1.
	
	self assert: (aCart includes: whiteBook).
	self assert: (aCart includes: blackBook).! !

!CartTest methodsFor: 'cartTests' stamp: 'Jamardo 6/13/2012 17:44'!
test04addingBooksMustThrowExceptionIfQuantityIsLessThanOne

	| aCart aBook |
	
	aCart := self cart.
	aBook := Book withIsbn: 123 andPrice: 5.
	[aCart addToCart: aBook withQuantity: -1.
	 self fail ]
		on: Error
		do: [ :anError | 
			self assert: anError messageText = Cart quantityMustNotBeLessThanOneErrorMessage. ]! !

!CartTest methodsFor: 'cartTests' stamp: 'Jamardo 6/13/2012 17:46'!
test05IsbnOfBookToAddMustBeInTheCatalog

	| redBook aCatalog aCart|
	redBook := Book withIsbn: 999 andPrice: 5.
	aCatalog := self catalog.
	aCart := Cart emptyWithCatalog: aCatalog.

	[aCart addToCart: redBook withQuantity: 1.
	 self fail ]
		on: Error
		do: [ :anError | 
			self assert: anError messageText = Cart bookMustBeInTheCatalogErrorMessage. ]! !

!CartTest methodsFor: 'cartTests' stamp: 'Jamardo 6/13/2012 17:45'!
test06WhenAddingABookAlreadyInTheCartTheQuantityMustBeThePreviousQuantityPlusTheAddingQuantity

	| aCart whiteBook |
	
	aCart := self cart.
	whiteBook := Book withIsbn: 123 andPrice: 5.
	aCart addToCart: whiteBook withQuantity: 1.
	aCart addToCart: whiteBook withQuantity: 2.
	
	self assert: ((aCart quantityOf: whiteBook) = 3)! !

!CartTest methodsFor: 'cartTests' stamp: 'Jamardo 6/13/2012 17:45'!
test07TheQuantityOfABookInTheCartCanNotBeLargerThanTheQuantityLeftInTheCatalog

	| aCart whiteBook |
	
	aCart := self cart.
	whiteBook := Book withIsbn: 123 andPrice: 5.
	
	[aCart addToCart: whiteBook withQuantity: 30.
	 self fail ]
		on: Error
		do: [ :anError | 
			self assert: anError messageText = Cart quantityCanNotExceedTheCatalogErrorMessage. ]! !
